org.eclipse.viatra.cep.core.engine.compiler

## Class NotPatternMatcher

- java.lang.Object
- - org.eclipse.viatra.query.runtime.internal.apiimpl.QueryResultWrapper
  - - org.eclipse.viatra.query.runtime.api.impl.BaseMatcher<NotPatternMatch>
    - - org.eclipse.viatra.cep.core.engine.compiler.NotPatternMatcher

- All Implemented Interfaces:
    ViatraQueryMatcher<NotPatternMatch>

      public class NotPatternMatcher
      extends BaseMatcher<NotPatternMatch>

  Generated pattern matcher API of the org.eclipse.viatra.cep.core.engine.compiler.notPattern pattern, providing pattern-specific query methods.

  Use the pattern matcher on a given model via `on(ViatraQueryEngine)`, e.g. in conjunction with `ViatraQueryEngine#on(Notifier)`.

  Matches of the pattern will be represented as `NotPatternMatch`.

  Original source: ``

       pattern notPattern(eventPattern : ComplexEventPattern) {
              find complexPattern(eventPattern, operator);
              NEG(operator);
       }

  See Also:
    `NotPatternMatch`, `NotPatternProcessor`, `NotPatternQuerySpecification`

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.api.impl.BaseMatcher

      `engine, querySpecification`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.internal.apiimpl.QueryResultWrapper

      `backend`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected NotPatternMatch` | `arrayToMatch(java.lang.Object[] match)` Converts the array representation of a pattern match to an immutable Match object.
    `protected NotPatternMatch` | `arrayToMatchMutable(java.lang.Object[] match)` Converts the array representation of a pattern match to a mutable Match object.
    `int` | `countMatches(ComplexEventPattern pEventPattern)` Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
    `static NotPatternMatcher` | `create()`
    `void` | `forEachMatch(ComplexEventPattern pEventPattern, IMatchProcessor<? super NotPatternMatch> processor)` Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
    `boolean` | `forOneArbitraryMatch(ComplexEventPattern pEventPattern, IMatchProcessor<? super NotPatternMatch> processor)` Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
    `java.util.Collection<NotPatternMatch>` | `getAllMatches(ComplexEventPattern pEventPattern)` Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
    `java.util.Set<ComplexEventPattern>` | `getAllValuesOfeventPattern()` Retrieve the set of values that occur in matches for eventPattern.
    `NotPatternMatch` | `getOneArbitraryMatch(ComplexEventPattern pEventPattern)` Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters.
    `boolean` | `hasMatch(ComplexEventPattern pEventPattern)` Indicates whether the given combination of specified pattern parameters constitute a valid pattern match, under any possible substitution of the unspecified parameters (if any).
    `NotPatternMatch` | `newMatch(ComplexEventPattern pEventPattern)` Returns a new (partial) match.
    `static NotPatternMatcher` | `on(ViatraQueryEngine engine)` Initializes the pattern matcher within an existing VIATRA Query engine.
    `static IQuerySpecification<NotPatternMatcher>` | `querySpecification()`
    `protected java.util.Set<ComplexEventPattern>` | `rawAccumulateAllValuesOfeventPattern(java.lang.Object[] parameters)` Retrieve the set of values that occur in matches for eventPattern.
    `protected NotPatternMatch` | `tupleToMatch(Tuple t)`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.api.impl.BaseMatcher

      `countMatches, countMatches, emptyArray, forEachMatch, forEachMatch, forOneArbitraryMatch, forOneArbitraryMatch, getAllMatches, getAllMatches, getAllValues, getAllValues, getCapabilities, getEngine, getOneArbitraryMatch, getOneArbitraryMatch, getParameterNames, getPatternName, getPositionOfParameter, getSpecification, hasMatch, matchToArray, newEmptyMatch, newMatch, rawAccumulateAllValues, rawCountMatches, rawForEachMatch, rawForOneArbitraryMatch, rawGetAllMatches, rawGetAllValues, rawGetOneArbitraryMatch, rawHasMatch, setBackend`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### on

          public static NotPatternMatcher on(ViatraQueryEngine engine)
                                      throws ViatraQueryException

      Initializes the pattern matcher within an existing VIATRA Query engine. If the pattern matcher is already constructed in the engine, only a light-weight reference is returned. The match set will be incrementally refreshed upon updates.
      Parameters:
        `engine` - the existing VIATRA Query engine in which this matcher will be created.
      Throws:
        `ViatraQueryException` - if an error occurs during pattern matcher creation

    - #### create

          public static NotPatternMatcher create()
                                          throws ViatraQueryException

      Returns:
        an initialized matcher
      Throws:
        `ViatraQueryException` - if an error occurs during pattern matcher creation
      No Reference:
        This method is for internal matcher initialization by the framework, do not call it manually.

    - #### getAllMatches

          public java.util.Collection<NotPatternMatch> getAllMatches(ComplexEventPattern pEventPattern)

      Returns the set of all matches of the pattern that conform to the given fixed values of some parameters.
      Parameters:
        `pEventPattern` - the fixed value of pattern parameter eventPattern, or null if not bound.
      Returns:
        matches represented as a NotPatternMatch object.

    - #### getOneArbitraryMatch

          public NotPatternMatch getOneArbitraryMatch(ComplexEventPattern pEventPattern)

      Returns an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters. Neither determinism nor randomness of selection is guaranteed.
      Parameters:
        `pEventPattern` - the fixed value of pattern parameter eventPattern, or null if not bound.
      Returns:
        a match represented as a NotPatternMatch object, or null if no match is found.

    - #### hasMatch

          public boolean hasMatch(ComplexEventPattern pEventPattern)

      Indicates whether the given combination of specified pattern parameters constitute a valid pattern match, under any possible substitution of the unspecified parameters (if any).
      Parameters:
        `pEventPattern` - the fixed value of pattern parameter eventPattern, or null if not bound.
      Returns:
        true if the input is a valid (partial) match of the pattern.

    - #### countMatches

          public int countMatches(ComplexEventPattern pEventPattern)

      Returns the number of all matches of the pattern that conform to the given fixed values of some parameters.
      Parameters:
        `pEventPattern` - the fixed value of pattern parameter eventPattern, or null if not bound.
      Returns:
        the number of pattern matches found.

    - #### forEachMatch

          public void forEachMatch(ComplexEventPattern pEventPattern,
                                   IMatchProcessor<? super NotPatternMatch> processor)

      Executes the given processor on each match of the pattern that conforms to the given fixed values of some parameters.
      Parameters:
        `pEventPattern` - the fixed value of pattern parameter eventPattern, or null if not bound.
        `processor` - the action that will process each pattern match.

    - #### forOneArbitraryMatch

          public boolean forOneArbitraryMatch(ComplexEventPattern pEventPattern,
                                              IMatchProcessor<? super NotPatternMatch> processor)

      Executes the given processor on an arbitrarily chosen match of the pattern that conforms to the given fixed values of some parameters. Neither determinism nor randomness of selection is guaranteed.
      Parameters:
        `pEventPattern` - the fixed value of pattern parameter eventPattern, or null if not bound.
        `processor` - the action that will process the selected match.
      Returns:
        true if the pattern has at least one match with the given parameter values, false if the processor was not invoked

    - #### newMatch

          public NotPatternMatch newMatch(ComplexEventPattern pEventPattern)

      Returns a new (partial) match. This can be used e.g. to call the matcher with a partial match.

      The returned match will be immutable. Use `BaseMatcher.newEmptyMatch()` to obtain a mutable match object.

      Parameters:
        `pEventPattern` - the fixed value of pattern parameter eventPattern, or null if not bound.
      Returns:
        the (partial) match object.

    - #### rawAccumulateAllValuesOfeventPattern

          protected java.util.Set<ComplexEventPattern> rawAccumulateAllValuesOfeventPattern(java.lang.Object[] parameters)

      Retrieve the set of values that occur in matches for eventPattern.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### getAllValuesOfeventPattern

          public java.util.Set<ComplexEventPattern> getAllValuesOfeventPattern()

      Retrieve the set of values that occur in matches for eventPattern.
      Returns:
        the Set of all values or empty set if there are no matches

    - #### tupleToMatch

          protected NotPatternMatch tupleToMatch(Tuple t)

      Specified by:
        `tupleToMatch` in class `BaseMatcher<NotPatternMatch>`

    - #### arrayToMatch

          protected NotPatternMatch arrayToMatch(java.lang.Object[] match)

      Description copied from class: `BaseMatcher`
      Converts the array representation of a pattern match to an immutable Match object.
      Specified by:
        `arrayToMatch` in class `BaseMatcher<NotPatternMatch>`

    - #### arrayToMatchMutable

          protected NotPatternMatch arrayToMatchMutable(java.lang.Object[] match)

      Description copied from class: `BaseMatcher`
      Converts the array representation of a pattern match to a mutable Match object.
      Specified by:
        `arrayToMatchMutable` in class `BaseMatcher<NotPatternMatch>`

    - #### querySpecification

          public static IQuerySpecification<NotPatternMatcher> querySpecification()
                                                                           throws ViatraQueryException

      Returns:
        the singleton instance of the query specification of this pattern
      Throws:
        `ViatraQueryException` - if the pattern definition could not be loaded